/*================================================================================
	
	-------------------------------------------
	-*- [ZP] Server Addon: Real Lighting 1.3 -*-
	-------------------------------------------
	
	~~~~~~~~~~~~~~~
	- Description -
	~~~~~~~~~~~~~~~
	Automatically changes light on a map during a round on that which is set in cvars. 
	How many times light will change similarly depends on cvars. 
	Some defects are possible with плагинами [ZP] Countdown, So that them it is better to clean
	WARNING!!! It is necessary to do restart, after changing of map for work plugin!!!

	~~~~~~~~~~~~~~~
	- Changelog -
	~~~~~~~~~~~~~~~
	v. 1.0 - Plugin Released. Testing...
	v. 1.1 - Fixed Bugs, no work lighting + added new cvarrs
	v. 1.2 - Optimized codes, and fixed bugs (round bugs) in version 1.0
	v. 1.3 - Added Multilangual System (3 languages). Version Released
================================================================================*/

#include <amxmodx>
#include <zombieplague>

#define PLUGIN "[ZP] Server Addon: Real Lighting"
#define VERSION "1.3"
#define AUTHOR "Re.Act!ve"
#pragma tabsize 0

new g_round_time
new g_time, g_timedown, g_start_light
new g_sound_event, g_hud_event
// new g_one, g_two, g_three, g_four

new g_time1
new const light_sound[] = { "ambience/wolfhowl01.wav" } // Sound

// Zombie Classes MUST be registered on plugin_precache

public plugin_precache()
{
		precache_sound( light_sound )
}

public plugin_init()
{
	g_round_time = register_cvar("zp_light_change", "60")			// Менять Освещение каждые Х секунд
	g_start_light = register_cvar("zp_light_start", "1")				// Освещение в начале раунда, если (2 - очень светло, 1 - день, 0 - ближе к вечеру)
	g_hud_event = register_cvar("zp_hud_light", "1")				// HUD сообщение о смене времени (1 - да / 0 - нет)
	g_sound_event = register_cvar("zp_sound_light", "1")			// Проигрывать звук при смене времени (1 - да / 0 - нет)
	register_event("HLTV", "RoundStart", "a", "1=0", "2=0")
	register_dictionary("zp_real_lighting.txt")
	register_plugin(PLUGIN, VERSION, AUTHOR)			
}

public RoundStart()
{
	if(get_pcvar_num(g_start_light) == 0)
		server_cmd("zp_lighting f")
	if(get_pcvar_num(g_start_light) == 1)
		server_cmd("zp_lighting h")
	if(get_pcvar_num(g_start_light) == 2)
		server_cmd("zp_lighting k")	

	set_task(3.0 , "light_change");
	g_time = get_pcvar_num(g_round_time);
	g_timedown = get_pcvar_num(g_round_time) - 1;
	g_time1 = 1
}

public light_change()
{	
	g_time--	
				if( (g_time < 2) && (g_time1 == 1) )
				{
					server_cmd("zp_lighting e") 			// Light changed 1 times
					if(get_pcvar_num(g_hud_event)) 
					{
					set_hudmessage(215, 200, 0, 0.05, 0.45, 0, 0.0, 3.0, 2.0, 1.0, -1)
					show_hudmessage(0, "%L", LANG_PLAYER, "HUD_EVENT") 
					} 
					if(get_pcvar_num(g_sound_event))
				emit_sound( 0, CHAN_STREAM, light_sound, 1.0, ATTN_NORM, 0, PITCH_HIGH )	

				}
				if( (g_time < 2) && (g_time1 == 2) )
				{
					server_cmd("zp_lighting d") 			// Light changed 2 times
					if(get_pcvar_num(g_hud_event)) 
					{
					set_hudmessage(215, 200, 0, 0.05, 0.45, 0, 0.0, 3.0, 2.0, 1.0, -1)
					show_hudmessage(0, "%L", LANG_PLAYER, "HUD_EVENT") 
					} 
					if(get_pcvar_num(g_sound_event))
				emit_sound( 0, CHAN_STREAM, light_sound, 1.0, ATTN_NORM, 0, PITCH_HIGH )
				}
				if( (g_time < 2) && (g_time1 == 3) )
				{
					server_cmd("zp_lighting c") 			// Light changed 3 times
					if(get_pcvar_num(g_hud_event)) 
					{
					set_hudmessage(215, 200, 0, 0.05, 0.45, 0, 0.0, 3.0, 2.0, 1.0, -1)
					show_hudmessage(0, "%L", LANG_PLAYER, "HUD_EVENT") 
					} 
					if(get_pcvar_num(g_sound_event))
				emit_sound( 0, CHAN_STREAM, light_sound, 1.0, ATTN_NORM, 0, PITCH_HIGH )
				}
				if( (g_time < 2) && (g_time1 == 4) )
				{
					server_cmd("zp_lighting b") 			// Light changed 4 times
					if(get_pcvar_num(g_hud_event)) 
					{					
					set_hudmessage(215, 200, 0, 0.05, 0.45, 0, 0.0, 3.0, 2.0, 1.0, -1)
					show_hudmessage(0, "%L", LANG_PLAYER, "HUD_EVENT") 
					} 
					if(get_pcvar_num(g_sound_event))
				emit_sound( 0, CHAN_STREAM, light_sound, 1.0, ATTN_NORM, 0, PITCH_HIGH )
				}
				if( (g_time < 2) && (g_time1 == 5) )
				{
					server_cmd("zp_lighting a") 			// Light changed 5 times
					if(get_pcvar_num(g_hud_event)) 
					{
					set_hudmessage(215, 200, 0, 0.05, 0.45, 0, 0.0, 3.0, 2.0, 1.0, -1)
					show_hudmessage(0, "%L", LANG_PLAYER, "HUD_EVENT") 
					} 
					if(get_pcvar_num(g_sound_event))
				emit_sound( 0, CHAN_STREAM, light_sound, 1.0, ATTN_NORM, 0, PITCH_HIGH )
				}
			
	--g_timedown;
if(g_time > 1)
    {
        set_task(1.0, "light_change")
    }
else 
	{
// if(g_time <= 1) 
	g_time = get_pcvar_num(g_round_time)
	g_time1 = g_time1 + 1
	set_task(0.1,"light_change")
	// g_lights[33] = get_pcvar_num(g_num_light)
	}
}